Subject: Re: [swh-devel] No releases/revisions in /snapshot endpoints?

From: Antoine Lambert <[email-masked]>
Date: Mon, 12 Feb 2024 17:37:22 +0100

Hello Ludovic,

The SWH data model also allows for snapshot branches to target simple directories.

The new loaders we implemented to ingest a tarball content (visit type: tarball-directory)
or a directory targeted by a CVS tag or commit (visit types: git-checkout, hg-checkout)
produce such snapshot with a single non alias branch targeting a directory.

We do not produce revisions or releases with these loaders as their purpose is to
archive a single directory (with extid mapping) without any development history.

Antoine Lambert

On 12/02/2024 17:04, Ludovic Courtès wrote:
> Dear SWH,
>
> In <https://issues.guix.gnu.org/69070> I stumbled upon what might be new
> behavior from the /snapshot endpoint:
>
>> The crux of the problem is that ‘snapshot-branches’ used to return
>> either a “revision” or a “release”, but now it can also return a
>> “directory”:
>>
>> $ wget -qO- https://archive.softwareheritage.org/api/1/snapshot/c405490b80fb35cc58b34260d9ec6add8248857f |jq
>> {
>>    "id": "c405490b80fb35cc58b34260d9ec6add8248857f",
>>    "branches": {
>>      "1.3.2": {
>>        "target": "e4a4be18fae8d9c6528abff3bc9088feb19a76c7",
>>        "target_type": "directory",
>>        "target_url": "https://archive.softwareheritage.org/api/1/directory/e4a4be18fae8d9c6528abff3bc9088feb19a76c7/"
>>      },
>>      "HEAD": {
>>        "target": "1.3.2",
>>        "target_type": "alias",
>>        "target_url": "https://archive.softwareheritage.org/api/1/directory/e4a4be18fae8d9c6528abff3bc9088feb19a76c7/"
>>      }
>>    },
>>    "next_branch": null
>> }
> Current documentation mentions the ‘target_types’ query parameter, which
> I could use to restrict results to “revision” and “release”:
>
>    https://archive.softwareheritage.org/api/1/snapshot/doc/
>
> However, that’d be the empty list of the case above.
>
> Other snapshots seem to be missing releases and revisions as well, such
> as this one:
>
>    https://archive.softwareheritage.org/api/1/snapshot/55bda9214f962550baad25026fb3ac3ad12e3eb9/
>
> Did anything change here?  Am I holding it wrong?  :-)
>
> Thanks in advance,
> Ludo’.

-- 
Antoine Lambert
Software engineer for Software Heritage
https://www.softwareheritage.org
Inria, Paris